#!/usr/bin/perl 

use strict;
use bytes;
use IO::Socket;
use POSIX ":sys_wait_h";

my $listeners = 20;
my $serverport = 8080; 

sub reaper {
  while ((my $child = waitpid(-1,WNOHANG)) > 0) {}
};

$SIG{'CHLD'} = \&reaper;

my $socket = IO::Socket::INET->new(     Listen => $listeners,
                                        LocalPort => $serverport,
					Reuse => 1,
                                        Proto => 'tcp');

my $client;

print "Waiting for people to phone home on $serverport\n";

while(1){
  $client = $socket->accept;
  unless(fork()){
    # child code executing now

    unless(defined($client)){exit;}
    my $peeraddr = $client->peerhost;
    $peeraddr .= " ";
    $peeraddr .= localtime;

    print "\n\n*** Connection from $peeraddr\n";

    # find request
    my $request;
    my $buffer;
    while(sysread($client,$buffer,1)){
        $request .= $buffer;
        syswrite(STDOUT,$buffer,1);
        if($request =~ m/\r*\n/mgsi){
          last;
        }
    }

    open(my $LOGFILE,">>connectlog/phonehome.$peeraddr.log") 
    or print STDERR "\nCan't log!\n";
    my $logmsg = "$peeraddr Full Data: $request\n";
    if(defined($LOGFILE)){
      print $LOGFILE $logmsg;
      close($LOGFILE);
    }
    print $logmsg;
    
    if($request =~ m/BitTorrent protocol/mgsi){
      print "Blocking IP $peeraddr, since they are wasting my bandwidth...\n";
      print "Add this line to your torrc, then: killall -HUP tor\n";
      print "ExitPolicy reject $peeraddr:*\n";
      
      system("iptables -I INPUT -s $peeraddr -j REJECT");
      system("iptables -I OUTPUT -s $peeraddr -j REJECT");
    }

    shutdown($client,2);
    exit;
  }
}
